VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   213
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   312
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox Picture3 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   1695
      Left            =   1680
      ScaleHeight     =   113
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   193
      TabIndex        =   5
      Top             =   1080
      Width           =   2895
   End
   Begin VB.PictureBox Picture2 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   375
      Left            =   1680
      ScaleHeight     =   25
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   193
      TabIndex        =   4
      Top             =   480
      Width           =   2895
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Write Out"
      Height          =   375
      Left            =   120
      TabIndex        =   3
      Top             =   600
      Width           =   1215
   End
   Begin VB.CommandButton Command1 
      Caption         =   "load"
      Height          =   375
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   1215
   End
   Begin VB.PictureBox Picture1 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   495
      Left            =   120
      ScaleHeight     =   33
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   81
      TabIndex        =   0
      Top             =   1080
      Width           =   1215
   End
   Begin VB.Label Label1 
      Caption         =   "Label1"
      Height          =   615
      Left            =   2040
      TabIndex        =   2
      Top             =   0
      Width           =   2535
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private colors(255) As Long
Private cards(53, 100, 100) As Byte

Private col As Integer
Private wcard As Integer, hcard As Integer
Private writestate As Integer
Private writenum As Long
Private writetemp



Private Sub Command1_Click()
col = 0
For i = 1 To 53
a$ = Right("0" + Trim(Str(i)), 2)
Picture1.Picture = LoadPicture("c:\projects\gbahearts\cards\c" + a$ + ".bmp")
w = Picture1.Width
wcard = w
h = Picture1.Height
hcard = h
For y = 0 To h - 1
For x = 0 To w - 1
c = pc2gbacol(Picture1.Point(x, y))
    f = 0
    For j = 0 To col - 1
        If colors(j) = c Then f = 1: cc = j: Exit For
    Next j
    If f = 0 Then
        col = col + 1: colors(col - 1) = c
        cc = col - 1
    End If
    cards(i, x, y) = cc
    
Picture1.PSet (x, y), gba2pccol(c) Xor &HFFFFFF
Next x
DoEvents
Next y
Label1 = Str(col) + " Unique GBA Colors"
UpdateColors

Next i

End Sub

Private Sub UpdateColors()
Picture2.Cls
If col = 0 Then Exit Sub
w = (Picture2.Width / col)
h = Picture2.Height
For i = 0 To col - 1
Picture2.Line (w * i, 0)-(w * i + w - 1, h), gba2pccol(colors(i)), BF
Next i
End Sub

Public Function gba2pccol(color)
r = color Mod 32
g = (color \ 32) Mod 32
b = (color \ (32 * 32)) Mod 32
gba2pccol = r * 8 + (g * 256 * 8) + (b * 65536 * 8)

End Function
Public Function pc2gbacol(color)
r = color Mod 256
g = (color \ 256) Mod 256
b = (color \ 65536) Mod 256
pc2gbacol = (r \ 8 + ((g \ 8) * 32) + ((b \ 8) * 32 * 32))

End Function

Private Sub Command2_Click()
Open "c:\projects\gbahearts\carddata.c" For Output As #1
Print #1, "#include ""gba.h"""
Print #1, ""
Print #1, "// Palette Info:"
Print #1, "const u16 cardpal[] = {"
Print #1, "    ";
For i = 0 To col - 1
Print #1, "0x"; Hex(colors(i));
If i < col - 1 Then Print #1, ",";
Next i
Print #1, ""
Print #1, "    };"
Print #1, ""
Print #1, "// width:" & (wcard) & "  height:" & (hcard)
Print #1, "// treat as u8 with 0xYZ where y is first pixel, Z is second"
Print #1, "// there are " & (hcard * wcard + 3) \ 4 * 2 & "bytes per card."
Print #1, "// Actual Card Data:"
Print #1, "const u16 carddata[] = {"
Picture3.Width = wcard * 2 + 1
gx = 0
gy = 0
gg = 0
InitState
For i = 1 To 53
    
    For y = 0 To hcard - 1
    For x = 0 To wcard - 1
    AddByte (cards(i, x, y))
    gg = gg + 1
    Picture3.PSet (gx, gy), gba2pccol(colors(cards(i, x, y)))
    gx = gx + 1
    If gx = Picture3.Width - 1 Then
        gy = gy + 1
        gx = 0
        If gy = Picture3.Height - 1 Then gy = 0
    End If
    
    Next x
    DoEvents
    Next y
    
    If writestate = 0 Then
        If (i <> 53) Then Print #1, ",";
        Print #1, ""
    Else
        Print #1, ",";
        If writenum Mod 100 = 99 Then Print #1, ""
        writenum = writenum + 1
        Print #1, "0x"; Hex(writetemp)
    End If
    writestate = 0
    
Next i
'WriteOut


Print #1, "};"
Close
End Sub


Private Sub InitState()
writestate = 0
writenum = 0
writetemp = 0
End Sub
Private Sub AddByte(byt)
Select Case writestate
Case 0
writestate = 1
writetemp = byt * 16
Case 1
writestate = 2
writetemp = writetemp + byt
Case 2
writestate = 3
writetemp = writetemp + byt * 256 * 16
Case 3
writestate = 0
writetemp = writetemp + byt * 256
If writenum > 0 Then Print #1, ",";
If writenum Mod 100 = 99 Then Print #1, ""
writenum = writenum + 1
Print #1, "0x"; Hex(writetemp);
End Select
End Sub
Private Sub WriteOut()
If writestate = 0 Then
    Print #1, ""
    Exit Sub
End If
If writenum > 0 Then Print #1, ",";
If writenum Mod 100 = 99 Then Print #1, ""
writenum = writenum + 1
Print #1, "0x"; Hex(writetemp)

End Sub
